{-

MDULO ERRORMESSAGES:
	Construo das diversas mensagens de erro do programa

Equipe:
	Andr Wilson Brotto Furtado
	Gustavo Danzi de Andrade
	Monique Luise Barros Monteiro
-}

module ErrorMessages where

import Lexparser
import Util

----------------------------------------------
-- FUNES QUE FORMAM ERROS NA VERIFICAO  --
--        SEMNTICA DO COMPILADOR           --
----------------------------------------------

errorIdentNotDeclared :: String -> String
errorIdentNotDeclared ident = "\nERRO: O identificador <" ++ ident ++ "> nao foi previamente declarado!"

errorUnmatchedType :: Expressao -> Type -> Type -> String
errorUnmatchedType expression expected notmatch  = "\nERRO: tipo errado na expressao: " ++ (show expression) ++
					           "\n\tTipo esperado: " ++ (show expected) ++
					           "\n\tTipo inferido: " ++ (show notmatch)

errorUnmatchedExpression :: Expressao -> Type -> Expressao -> Type -> String
errorUnmatchedExpression exp1 type1 exp2 type2 = "ERRO: casamento de tipos errado!" ++
					           "\n      Expressao: " ++ (show exp1) ++
 				               "\n      Tipo: " ++ (show type1) ++
 				               "\n      Nao casa com:" ++
 				               "\n      Expressao: " ++ (show exp2) ++
 				               "\n      Tipo: " ++ (show type2)

errorIdentAlreadyDeclared :: String -> String
errorIdentAlreadyDeclared ident = "\nERRO: O identificador <" ++ ident ++ "> ja foi previamente declarado!"

------------------------------------------------
-- FUNES QUE FORMAM WARNINGS NA VERIFICAO --
-- SEMNTICA DO COMPILADOR                    --
------------------------------------------------

warningIdentAlreadyDeclared :: String -> String
warningIdentAlreadyDeclared ident = "\nWARNING: O identificador <" ++ ident ++ "> estah sendo redeclarado!"
