{-
MDULO SEMANTIC:


Equipe:
	Andr Wilson Brotto Furtado
	Gustavo Danzi de Andrade
	Monique Luise Barros Monteiro
-}

module Semantic where

import Lexparser

data Type = TypeInt | TypeBool | TypeString
     deriving (Eq)

----------------------------------------------------------------------------------
--      INFERNCIA DO TIPO DO PROGRAMA PARA A GERO DE CDIGO FINAL            --
----------------------------------------------------------------------------------
getProgramType :: Programa -> Type
getProgramType (Programa exp) = getTypeExpressao exp

getTypeExpressao :: Expressao -> Type
getTypeExpressao (ExpressaoValor valor) =  getTypeValor valor
getTypeExpressao (ExpressaoUnaria expUnaria) = getTypeExpUnaria expUnaria
getTypeExpressao (ExpressaoBinaria expBinaria) = getTypeExpBinaria expBinaria
getTypeExpressao (ExpressaoDeclaracao expDeclaracao) = getTypeExpDeclaracao expDeclaracao
getTypeExpressao (ExpressaoId ident) = error $ "Varivel " ++ ident ++ " no declarada"

getTypeValor :: Valor -> Type
getTypeValor (Valor (ValorInteiro _)) = TypeInt
getTypeValor (Valor (ValorBooleano _)) = TypeBool
getTypeValor (Valor (ValorString _)) = TypeString

getTypeExpUnaria :: ExpUnaria -> Type
getTypeExpUnaria (PreMenos _) = TypeInt
getTypeExpUnaria (Not _) = TypeBool
getTypeExpUnaria (Length _) = TypeInt

getTypeExpBinaria :: ExpBinaria -> Type
getTypeExpBinaria (Mais _ _) = TypeInt
getTypeExpBinaria (Menos _ _) = TypeInt
getTypeExpBinaria (And _ _) = TypeBool
getTypeExpBinaria (Or _ _) = TypeBool
getTypeExpBinaria (Igual _ _) = TypeBool
getTypeExpBinaria (Concatenacao _ _) = TypeString

getTypeExpDeclaracao :: ExpDeclaracao -> Type
getTypeExpDeclaracao (LetIn _ exp) = getTypeExpressao exp


